open Unix
open Graphics

(* DATA TYPES *)

type tree = Leaf of string | Node of float * tree * tree
let db : (string, string list) Hashtbl.t = Hashtbl.create 101

(* UTILITIES *)

let rec filter_last = function
    (* removes last element from a list *)
  | [] -> assert false
  (* À compléter *)

let rec depth t =
  (* depth of a tree *)
  assert false

let rec size t =
  (* size of a tree *)
  assert false

(* READING DATA *)

let rec read_lines f n = match n with
  | 0 -> []
  | n -> let l = input_line f in
         match String.split_on_char ',' l with
         | t::q -> Hashtbl.add db t (filter_last q);
                   t::read_lines f (n-1)
         | _ -> assert false

let f = open_in "zoo.data"
let animaux = read_lines f 101
let () = close_in f

(* GRAPHICS *)

let draw str = let (w,_) = text_size str in
               draw_string str; rmoveto (-w) 0

let upto d = size_x () - 200 - int_of_float (50. *. d)

let dendrogramme tree offset =
  clear_graph (); moveto (upto 0.) offset;
  let rec dendro_aux tree x y = match tree with
    | Leaf a -> lineto (upto (-1.)) y; draw a; moveto (upto x) y
    | Node (d, tl, tr) ->
       let dy = 20 * size tl in
       lineto (upto d) y;
       dendro_aux tl d y;
       lineto (upto d) (y - dy);
       dendro_aux tr d (y - dy);
       moveto (upto x) y;
  in dendro_aux tree 2000. offset


(* CLASSIFICATION *)

let classify l =
  assert false

(* MAIN *)

let data animal = Hashtbl.find db animal;;

let classif = classify animaux

let () = open_graph ""

let draw tree =
  Unix.sleep 2;
  for offset = 0 to 60 do
    dendrogramme classif (size_y () - 20 + 50*offset);
    Unix.sleep 2;
  done
